%bcond_with bootstrap

Summary:    The Table engine for IBus platform
Name:       ibus-table
Version:    1.17.2
Release:    4%{?dist}
License:    LGPLv2+
URL:        https://github.com/mike-fabian/ibus-table
Source0:    %{url}/releases/download/%{version}/%{name}-%{version}.tar.gz

BuildRequires: gcc ibus-devel python3-devel docbook-utils libappstream-glib desktop-file-utils
BuildRequires: python3-gobject-base dbus-x11 xorg-x11-server-Xvfb python3-gobject make
%if %{with bootstrap}
BuildRequires: ibus-table-chinese-wubi-jidian ibus-table-chinese-cangjie
BuildRequires: ibus-table-chinese-stroke5
%endif
Requires:   ibus python3
Recommends: python3-simpleaudio
BuildArch:  noarch

%description
The Table engine for IBus platform.

%package -n %{name}-devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}, pkgconfig

%description -n %{name}-devel
Development files for %{name}.

%prep
%autosetup -n %{name}-%{version} -p1

%build
export PYTHON=%{__python3}
%configure \
    --disable-static \
    --disable-additional \
    --enable-installed-tests \
    %{nil}

%make_build

%install
rm -rf %{buildroot}
export PYTHON=%{__python3}
%make_install NO_INDEX=true pkgconfigdir=%{_datadir}/pkgconfig
%py_byte_compile %{python3} %{buildroot}/usr/share/ibus-table/engine
%py_byte_compile %{python3} %{buildroot}/usr/share/ibus-table/setup

%find_lang %{name}

%check
%if %{with bootstrap}
appstream-util validate-relax --nonet %{buildroot}/%{_datadir}/metainfo/*.appdata.xml
desktop-file-validate %{buildroot}%{_datadir}/applications/ibus-setup-table.desktop
pushd engine
    python3 table.py
    python3 it_util.py
popd

mkdir -p /tmp/glib-2.0/schemas/
cp org.freedesktop.ibus.engine.table.gschema.xml \
   /tmp/glib-2.0/schemas/org.freedesktop.ibus.engine.table.gschema.xml
glib-compile-schemas /tmp/glib-2.0/schemas
export XDG_DATA_DIRS=/tmp
eval $(dbus-launch --sh-syntax)
dconf dump /
dconf write /org/freedesktop/ibus/engine/table/wubi-jidian/chinesemode 1
dconf write /org/freedesktop/ibus/engine/table/wubi-jidian/spacekeybehavior false
dconf dump /
export DISPLAY=:1
Xvfb $DISPLAY -screen 0 1024x768x16 &

make check && rc=0 || rc=1
cat tests/*.log
if [ $rc != 0 ] ; then
    exit $rc
fi
%endif

%files -f %{name}.lang
%license COPYING
%doc AUTHORS README
%{_bindir}/%{name}-createdb
%{_libexecdir}/ibus-engine-table
%{_libexecdir}/ibus-setup-table
%{_datadir}/%{name}
%{_datadir}/metainfo/*.appdata.xml
%{_datadir}/ibus/component/table.xml
%{_datadir}/icons/hicolor/16x16/apps/ibus-table.png
%{_datadir}/icons/hicolor/22x22/apps/ibus-table.png
%{_datadir}/icons/hicolor/32x32/apps/ibus-table.png
%{_datadir}/icons/hicolor/48x48/apps/ibus-table.png
%{_datadir}/icons/hicolor/64x64/apps/ibus-table.png
%{_datadir}/icons/hicolor/128x128/apps/ibus-table.png
%{_datadir}/icons/hicolor/256x256/apps/ibus-table.png
%{_datadir}/icons/hicolor/scalable/apps/ibus-table.svg
%{_datadir}/applications/ibus-setup-table.desktop
%{_datadir}/glib-2.0/schemas/org.freedesktop.ibus.engine.table.gschema.xml
%{_mandir}/man1/*

%files devel
%dir %{_libexecdir}/installed-tests
%{_libexecdir}/installed-tests/%{name}
%{_datadir}/pkgconfig/%{name}.pc
%dir %{_datadir}/installed-tests
%{_datadir}/installed-tests/%{name}

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.17.2-4
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.17.2-3
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.17.2-2
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 22 2023 Wang Guodong <gordonwwang@tencent.com> - 1.17.2-1
- Upgrade to version 1.17.2

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.16.14-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.16.14-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Mar 13 2023 Shuo Wang <abushwang@tencent.com> - 1.16.14-1
- initial build
